diff --git a/sys/contrib/dev/acpica/source/tools/acpihelp/ahgrammar.c b/sys/contrib/dev/acpica/source/tools/acpihelp/ahgrammar.c
index 1e0d549746..d345893a1f 100644
--- a/sys/contrib/dev/acpica/source/tools/acpihelp/ahgrammar.c
+++ b/sys/contrib/dev/acpica/source/tools/acpihelp/ahgrammar.c
@@ -43,7 +43,7 @@
 
 #include "acpihelp.h"
 
-const AH_AML_TYPE           AmlTypesInfo[] =
+const AH_AML_TYPE           Gbl_AmlTypesInfo[] =
 {
     {"ComputationalData",
         "ComputationalData :=\n"
diff --git a/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c b/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
index 1c45e43626..b62ec62f5e 100644
--- a/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
+++ b/sys/contrib/dev/acpica/source/tools/acpihelp/ahmain.c
@@ -41,6 +41,7 @@
  * POSSIBILITY OF SUCH DAMAGES.
  */
 
+#define DEFINE_AHELP_GLOBALS
 #include "acpihelp.h"
 
 
@@ -61,6 +62,7 @@ AhDisplayUsage (
 #define ACPI_OPTION(Name, Description) \
     AcpiOsPrintf ("  %-24s%s\n", Name, Description);
 
+
 /******************************************************************************
  *
  * FUNCTION:    AhDisplayUsage
diff --git a/sys/contrib/dev/acpica/source/tools/efihello/efihello.c b/sys/contrib/dev/acpica/source/tools/efihello/efihello.c
new file mode 100644
index 0000000000..ac7a64ce71
--- /dev/null
+++ b/sys/contrib/dev/acpica/source/tools/efihello/efihello.c
@@ -0,0 +1,124 @@
+/******************************************************************************
+ *
+ * Module Name: efihello - very simple ACPICA/EFI integration example
+ *
+ *****************************************************************************/
+
+/*
+ * Copyright (C) 2000 - 2016, Intel Corp.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions, and the following disclaimer,
+ *    without modification.
+ * 2. Redistributions in binary form must reproduce at minimum a disclaimer
+ *    substantially similar to the "NO WARRANTY" disclaimer below
+ *    ("Disclaimer") and any redistribution must be conditioned upon
+ *    including a substantially similar Disclaimer requirement for further
+ *    binary redistribution.
+ * 3. Neither the names of the above-listed copyright holders nor the names
+ *    of any contributors may be used to endorse or promote products derived
+ *    from this software without specific prior written permission.
+ *
+ * Alternatively, this software may be distributed under the terms of the
+ * GNU General Public License ("GPL") version 2 as published by the Free
+ * Software Foundation.
+ *
+ * NO WARRANTY
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ * HOLDERS OR CONTRIBUTORS BE LIABLE FOR SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGES.
+ */
+
+#include "acpi.h"
+#include "accommon.h"
+#include "acapps.h"
+
+
+#define LINE_SIZE           256
+static char                 LineBuffer[LINE_SIZE];
+
+/******************************************************************************
+ *
+ * FUNCTION:    main
+ *
+ * PARAMETERS:  argc/argv           - Standard argc/argv
+ *
+ * RETURN:      Status
+ *
+ * DESCRIPTION: C main function for efihello
+ *
+ ******************************************************************************/
+
+#ifndef _GNU_EFI
+int ACPI_SYSTEM_XFACE
+main (
+    int                     argc,
+    char                    *argv[])
+#else
+int ACPI_SYSTEM_XFACE
+acpi_main (
+    int                     argc,
+    char                    *argv[])
+#endif
+{
+    ACPI_FILE               File;
+    BOOLEAN                 DoCloseFile = FALSE;
+    char                    *Result;
+
+
+    AcpiOsInitialize ();
+
+    printf ("argc=%d\n", argc);
+
+    if (argc > 1)
+    {
+        File = fopen (argv[1], "r");
+        if (!File)
+        {
+            printf ("Failed to open %s.\n", argv[1]);
+            return (-1);
+        }
+        DoCloseFile = TRUE;
+    }
+    else
+    {
+        File = stdin;
+    }
+
+    while (1)
+    {
+        Result = fgets (LineBuffer, LINE_SIZE, File);
+        if (!Result)
+        {
+            printf ("Failed to read %s.\n", argv[1]);
+            fclose (File);
+            return (-2);
+        }
+
+        printf ("%s", LineBuffer);
+
+        if (strncmp (Result, "exit", 4) == 0)
+        {
+            break;
+        }
+    }
+
+
+    if (DoCloseFile)
+    {
+        fclose (File);
+    }
+    return (0);
+}
diff --git a/sys/contrib/dev/acpica/tests/misc/grammar.asl b/sys/contrib/dev/acpica/tests/misc/grammar.asl
index 1b89e59993..080a36546a 100644
--- a/sys/contrib/dev/acpica/tests/misc/grammar.asl
+++ b/sys/contrib/dev/acpica/tests/misc/grammar.asl
@@ -965,19 +965,20 @@ DefinitionBlock (
         Store ("DIV0 - noabort", Debug)
     }
 
-    Method (ERR_, 1)
+    Method (ERR_, 2)
     {
+        Local0 = ToDecimalString (Arg1)
         if (LEqual (Arg0, 0))
         {
-            Store ("+*+*+*+* MTHD_ERROR: Results not equal!", Debug)
+            Printf ("+*+*+*+* MTHD_ERROR at line %o: Results not equal!", Local0)
         }
         if (LEqual (Arg0, 1))
         {
-            Store ("+*+*+*+* MTHD_ERROR: Numeric result is incorrect!", Debug)
+            Printf ("+*+*+*+* MTHD_ERROR at line %o: Numeric result is incorrect!", Local0)
         }
         if (LEqual (Arg0, 2))
         {
-            Store ("+*+*+*+* MTHD_ERROR: Operand was clobbered!", Debug)
+            Printf ("+*+*+*+* MTHD_ERROR at line %o: Operand was clobbered!", Local0)
         }
 
         Notify (DEV1, Arg0)
@@ -1033,245 +1034,245 @@ DefinitionBlock (
         Store (\IFEL.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\NOSV.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\IDXF.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.NSTL.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\RTBF.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.RTLV.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.RETP.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\WHLR.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\ANDO.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\BRKP.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\ADSU.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\INDC.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\LOPS.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\FDSO.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\MLDV.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\NBIT.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\SHFT.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\XORD.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\CRBF.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\IDX4.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\EVNT.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\SZLV.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.BYTF.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\DWDF.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\DVAX.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\IDX6.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\IDX5.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.IDX0.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.IDX3.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\IDX7.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\MTCH.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\WHLB.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.IDX2.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\SIZO.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
         Store (\_SB_.SMIS.TEST(), Local0)
         if (LGreater (Local0, 0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
             Return(Local0)
         }
 
@@ -1331,14 +1332,14 @@ DefinitionBlock (
         Store (BIT2, Local0)
         if (LNotEqual (Local0, 0x1))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
             Store (DerefOf (Index (BUF2, 0)), Local0)
             if (LNotEqual (Local0, 0x08))
             {
-                ERR_ (1)
+                ERR_ (1, __LINE__)
             }
             else
             {
@@ -1350,7 +1351,7 @@ DefinitionBlock (
         Store (BYT2, Local0)
         if (LNotEqual (Local0, 0x1A))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
@@ -1361,7 +1362,7 @@ DefinitionBlock (
         Store (WRD2, Local0)
         if (LNotEqual (Local0, 0x1234))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
@@ -1372,7 +1373,7 @@ DefinitionBlock (
         Store (FLD2, Local0)
         if (LNotEqual (Local0, 0x123))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
@@ -1383,7 +1384,7 @@ DefinitionBlock (
         Store (DWD2, Local0)
         if (LNotEqual (Local0, 0x12345678))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
@@ -1394,7 +1395,7 @@ DefinitionBlock (
         Store (QWD2, Local0)
         if (LNotEqual (Local0, 0x1234567887654321))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
         else
         {
@@ -1546,7 +1547,7 @@ DefinitionBlock (
         Store ("++++++++ Checking result from ADD", Debug)
         if (LNotEqual (Local0, Local1))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1561,7 +1562,7 @@ DefinitionBlock (
         Store ("++++++++ Checking result from SUBTRACT", Debug)
         if (LNotEqual (Local4, Local5))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1577,7 +1578,7 @@ DefinitionBlock (
         Store ("++++++++ Checking result from MULTIPLY", Debug)
         if (LNotEqual (Local6, Local7))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1592,7 +1593,7 @@ DefinitionBlock (
         Store ("++++++++ Checking (quotient) result from DIVIDE", Debug)
         if (LNotEqual (Local2, Local3))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1606,7 +1607,7 @@ DefinitionBlock (
         Store ("++++++++ Checking result from INCREMENT", Debug)
         if (LNotEqual (Local0, Local1))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1620,7 +1621,7 @@ DefinitionBlock (
         Store ("++++++++ Checking result from DECREMENT", Debug)
         if (LNotEqual (Local0, Local1))
         {
-            ERR_ (0)
+            ERR_ (0, __LINE__)
         }
 
 
@@ -1649,22 +1650,22 @@ DefinitionBlock (
         Add (Local0, Local1)
         if (LNotEqual (Local0, 3))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
         if (LNotEqual (Local1, 7))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
 
         Add (Local0, Local1, Local2)
         if (LNotEqual (Local0, 3))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
         if (LNotEqual (Local1, 7))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
     }
 
@@ -1692,63 +1693,63 @@ DefinitionBlock (
         FindSetLeftBit (0x00100100, Local0)
         if (LNotEqual (Local0, 21))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ FindSetRightBit (0x00100100, Local1)", Debug)
         FindSetRightBit (0x00100100, Local1)
         if (LNotEqual (Local1, 9))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ And (0xF0F0F0F0, 0x11111111, Local2)", Debug)
         And (0xF0F0F0F0, 0x11111111, Local2)
         if (LNotEqual (Local2, 0x10101010))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ NAnd (0xF0F0F0F0, 0x11111111, Local3)", Debug)
         NAnd (0xF0F0F0F0, 0x11111111, Local3)
         if (LNotEqual (Local3, 0xEFEFEFEF))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ Or (0x11111111, 0x22222222, Local4)", Debug)
         Or (0x11111111, 0x22222222, Local4)
         if (LNotEqual (Local4, 0x33333333))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ NOr (0x11111111, 0x22222222, Local5)", Debug)
         NOr (0x11111111, 0x22222222, Local5)
         if (LNotEqual (Local5, 0xCCCCCCCC))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ XOr (0x11113333, 0x22222222, Local6)", Debug)
         XOr (0x11113333, 0x22222222, Local6)
         if (LNotEqual (Local6, 0x33331111))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ ShiftLeft (0x11112222, 2, Local7)", Debug)
         ShiftLeft (0x11112222, 2, Local7)
         if (LNotEqual (Local7, 0x44448888))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Store ("++++++++ ShiftRight (Local7, 2, Local7)", Debug)
         ShiftRight (Local7, 2, Local7)
         if (LNotEqual (Local7, 0x11112222))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
 
@@ -1757,12 +1758,12 @@ DefinitionBlock (
         Not (Local0, Local1)
         if (LNotEqual (Local0, 0x22224444))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
         if (LNotEqual (Local1, 0xDDDDBBBB))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
         Return (Local7)
@@ -1795,12 +1796,12 @@ DefinitionBlock (
         Store (LNot (Local6), Local7)
         if (LNotEqual (Local6, 0x00001111))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
         if (LNotEqual (Local7, 0x0))
         {
-            ERR_ (1)
+            ERR_ (1, __LINE__)
         }
 
 
@@ -1933,25 +1934,25 @@ DefinitionBlock (
         Store (CondRefOf (ABCD, Local0), Local1)
         if (LNotEqual (Local1, 0))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
         Store (CondRefOf (BBUF, Local0), Local1)
         if (LNotEqual (Local1, Ones))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
         Store (DeRefOf (Index (BBUF, 3)), Local6)
         if (LNotEqual (Local6, 0xB3))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
         Store (DeRefOf (Index (DeRefOf (Index (NEST, 1)), 3)), Local0)
         if (LNotEqual (Local0, 0x14))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
 
@@ -1961,7 +1962,7 @@ DefinitionBlock (
         Store (DerefOf (Local1), Local2)
         If (LNotEqual (Local2, 0x11223344))
         {
-            ERR_ (2)
+            ERR_ (2, __LINE__)
         }
 
 
diff --git a/sys/dev/acpica/Osd/OsdDebug.c b/sys/dev/acpica/Osd/OsdDebug.c
index e5fd8f798c..1873d3d5d2 100644
--- a/sys/dev/acpica/Osd/OsdDebug.c
+++ b/sys/dev/acpica/Osd/OsdDebug.c
@@ -44,6 +44,8 @@
 #include "acpivar.h"
 #include "acdebug.h"
 
+ACPI_MODULE_NAME("DEBUG")
+
 ACPI_STATUS
 AcpiOsGetLine(char *Buffer, UINT32 BufferLength, UINT32 *BytesRead)
 {
@@ -93,16 +95,56 @@ AcpiOsSignal(UINT32 Function, void *Info)
 }
 
 #ifdef ACPI_DEBUGGER
-DB_COMMAND(acpidb, db_cmd_acpidb)
+ACPI_STATUS
+AcpiOsInitializeDebugger(void)
 {
-    kprintf("Entering ACPICA debugger...\n");
-    while (!AcpiGbl_DbTerminateLoop) {
+	return (AE_OK);
+}
+
+void
+AcpiOsTerminateDebugger(void)
+{
+}
+
+ACPI_STATUS
+AcpiOsWaitCommandReady(void)
+{
+	ACPI_STATUS Status;
+
+	/* Force output to console until a command is entered */
+
 	AcpiDbSetOutputDestination(ACPI_DB_CONSOLE_OUTPUT);
+
+	/* Different prompt if method is executing */
+
 	if (!AcpiGbl_MethodExecuting)
-	    AcpiOsPrintf("%1c ", ACPI_DEBUGGER_COMMAND_PROMPT);
+		AcpiOsPrintf("%1c ", ACPI_DEBUGGER_COMMAND_PROMPT);
 	else
-	    AcpiOsPrintf("%1c ", ACPI_DEBUGGER_EXECUTE_PROMPT);
-	AcpiOsGetLine(AcpiGbl_DbLineBuf, ACPI_DB_LINE_BUFFER_SIZE, NULL);
+		AcpiOsPrintf("%1c ", ACPI_DEBUGGER_EXECUTE_PROMPT);
+
+	/* Get the user input line */
+
+	Status = AcpiOsGetLine(AcpiGbl_DbLineBuf,
+	    ACPI_DB_LINE_BUFFER_SIZE, NULL);
+
+	if (ACPI_FAILURE (Status) && Status != AE_CTRL_TERMINATE)
+		ACPI_EXCEPTION ((AE_INFO, Status,
+			"While parsing/handling command line"));
+	return (Status);
+}
+
+ACPI_STATUS
+AcpiOsNotifyCommandComplete(void)
+{
+	return (AE_OK);
+}
+
+DB_COMMAND(acpidb, db_cmd_acpidb)
+{
+    kprintf("Entering ACPICA debugger...\n");
+    while (!AcpiGbl_DbTerminateLoop) {
+	if (ACPI_FAILURE(AcpiOsWaitCommandReady()))
+	    break;
 	AcpiDbCommandDispatch(AcpiGbl_DbLineBuf, NULL, NULL);
     }
     AcpiGbl_DbTerminateLoop = FALSE;
diff --git a/sys/dev/acpica/Osd/OsdHardware.c b/sys/dev/acpica/Osd/OsdHardware.c
index 67783aef43..52753db103 100644
--- a/sys/dev/acpica/Osd/OsdHardware.c
+++ b/sys/dev/acpica/Osd/OsdHardware.c
@@ -124,3 +124,12 @@ AcpiOsWritePciConfiguration(ACPI_PCI_ID *PciId, UINT32 Register,
 
     return (AE_OK);
 }
+
+ACPI_STATUS
+AcpiOsEnterSleep (
+    UINT8                   SleepState,
+    UINT32                  RegaValue,
+    UINT32                  RegbValue)
+{
+    return (AE_OK);
+}
diff --git a/usr.sbin/acpi/acpiexec/Makefile b/usr.sbin/acpi/acpiexec/Makefile
index 91619189bd..383b4e0284 100644
--- a/usr.sbin/acpi/acpiexec/Makefile
+++ b/usr.sbin/acpi/acpiexec/Makefile
@@ -137,6 +137,7 @@ SRCS+=	\
 	nsxfeval.c \
 	nsxfname.c \
 	nsxfobj.c \
+	osgendbg.c \
 	osunixxf.c \
 	psargs.c \
 	psloop.c \
diff --git a/usr.sbin/acpi/acpihelp/Makefile b/usr.sbin/acpi/acpihelp/Makefile
index 261572f165..22d5583e3f 100644
--- a/usr.sbin/acpi/acpihelp/Makefile
+++ b/usr.sbin/acpi/acpihelp/Makefile
@@ -11,7 +11,9 @@ PROG=	acpihelp
 MAN=	acpihelp.8
 
 SRCS=	\
+	ahaml.c \
 	ahamlops.c \
+	ahasl.c \
 	ahaslkey.c \
 	ahaslops.c \
 	ahdecode.c \
-- 
2.11.0

